// MFC Console App.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "MFC Console App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// The one and only application object

CWinApp theApp;

using namespace std;

// Type definition for function declaration as specified by GoldSim External elements.
typedef void (__cdecl* LPFNDLLFUNC1)(int,int*,double*,double*);

#define XF_INITIALIZE			0
#define XF_CALCULATION			1
#define XF_REP_VERSION			2
#define XF_REP_ARGUMENTS		3
#define XF_CLEANUP				99
#define XF_FATAL				1

// Helper function to mimic GoldSim's External-element DLL execution stack.
void CallExternalDLLFunction(CString sDLLName, CString sFunctionName)
{
	// Map the DLL module in the process space of this process. 
	_tprintf(_T("Now loading DLL '%s'\n"), sDLLName);
	HINSTANCE hDLLHandle = ::LoadLibrary(sDLLName);

	// Get a function pointer to native function with GoldSim interface inside DLL.
	_tprintf(_T("Getting address of function '%s'\n"), sFunctionName);
	LPFNDLLFUNC1 pFunction = (LPFNDLLFUNC1)GetProcAddress(hDLLHandle, sFunctionName);

	// Declare standard GoldSim-style double arrays.
	double inargs[2];
	double outargs[2];

	// Query for DLL version.
	int nReturnCode = 0;
	pFunction(XF_REP_VERSION, &nReturnCode, inargs, outargs);
	_tprintf(_T("DLL Version: %g\n"), outargs[0]);

	// Query for DLL argument length.
	nReturnCode = 0;
	pFunction(XF_REP_ARGUMENTS, &nReturnCode, inargs, outargs);
	_tprintf(_T("Number of inputs: %d\n"), static_cast<int>(outargs[0]));
	_tprintf(_T("Number of outputs: %d\n"), static_cast<int>(outargs[1]));

	// Allow GoldSim DLL to initialize variables/data/structures used during simulation.
	nReturnCode = 0;
	pFunction(XF_INITIALIZE, &nReturnCode, inargs, outargs);

	// Fill double arrays with some sample data.
	nReturnCode = 0;
	inargs[0] = 25.0;
	inargs[1] = 17.25;
	outargs[0] = -100.0; // Set result to unexpected value.

	// Executed DLL calculation.
	pFunction(XF_CALCULATION, &nReturnCode, inargs, outargs);
	_tprintf(_T("%s(%g, %g) = %g\n"), sFunctionName, inargs[0], inargs[1], outargs[0]);

	// Allow GoldSim DLL to cleanup variables/data/structures used during simulation.
	pFunction(XF_CLEANUP, &nReturnCode, inargs, outargs);
	
	// Clear the function pointer.
	pFunction = NULL;

	// Free the DLL library (will be unloaded by system).
	FreeLibrary(hDLLHandle);

	// Clear DLL library handle.
	hDLLHandle = NULL;
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	HMODULE hModule = ::GetModuleHandle(NULL);

	if (hModule != NULL)
	{
		// initialize MFC and print and error on failure
		if (!AfxWinInit(hModule, NULL, ::GetCommandLine(), 0))
		{
			// TODO: change error code to suit your needs
			_tprintf(_T("Fatal Error: MFC initialization failed\n"));
			nRetCode = 1;
		}
		else
		{
			// Call function in intermediate mixed-mode DLL. This DLL then calls a .Net assembly.
			CallExternalDLLFunction(_T("Mixed Mode DLL.dll"), _T("MixedSum"));
			_tprintf(_T("DLL function successfully executed!\n\n"));
		}
	}
	else
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: GetModuleHandle failed\n"));
		nRetCode = 1;
	}

	return nRetCode;
}
